// set the database and collection we want to use
myDb = db.getSiblingDB('myDb3')
collection = myDb.myCollection
departments = myDb.departments

// clear all collection records in advance of CRUD demo
deleteStatus = myDb.myCollection.deleteMany({})

accounting = {
    "name": "Accounting",
    "id": "123",
    "manager": "stacey brock"
}

it = {
    "name": "IT",
    "id": "321",
    "manager": "katherine donald"
}


employee1 = {
    "firstName": "John",
    "lastName": "Smith",
    "email": "johnsmith@example.com",
    "department": "IT",
    "password": "abc123",
    "salary": 44000,
    "location": { // embedded document

        "city": "Columbus",
        "state": "Ohio"
    },
    "skills": ["programming", "mongoDb"],
    "hobbies": ["fishing"]
}

employee2 = {
    "firstName": "Jane",
    "lastName": "Bradley",
    "email": "janebradley@example.com",
    "department": "IT",
    "password": "xyz987",
    "salary": 71000,
    "location": { // embedded document

        "city": "Chicago",
        "state": "Illinois"
    },
    "skills": ["programming", "mySql"],
    "hobbies": ["hiking"]
}

employee3 = {
    "firstName": "Fred",
    "lastName": "Jones",
    "email": "fredjones@example.com",
    "department": "Accounting",
    "password": "scooby",
    "salary": 63000,
    "location": { // embedded document

        "city": "Chicago",
        "state": "Illinois"
    },
    "skills": ["tax law", "payroll"],
    "hobbies": ["sewing"]
}

employee4 = {
    "firstName": "Tom",
    "lastName": "Wilbert",
    "email": "tomwilbert@example.com",
    "department": "IT",
    "password": "123",
    "salary": 110000,
    "location": { // embedded document

        "city": "San Francisco",
        "state": "California"
    },
    "skills": ["programming", "golang"],
    "hobbies": ["skydiving"]
}

employee5 = {
    "firstName": "Tom",
    "lastName": "Wilbert",
    "email": "tomwilbert@example.com", // the same email
    "department": "IT",
    "password": "123",
    "salary": 110000,
    "location": { // embedded document

        "city": "San Francisco",
        "state": "California"
    },
    "skills": ["programming", "golang"],
    "hobbies": ["skydiving"]
}


// insert our employees
collection.insert(employee1)
collection.insert(employee2)
collection.insert(employee3)
collection.insert(employee4)
// insert duplicate employee
collection.insert(employee5)

// insert our departments
departments.insert(accounting)
departments.insert(it)

/*
    Aggregations
*/

//deduplicate

myDb.myCollection.aggregate([
    {
        "$group": {
            _id: {projectId: "$email"},
            dups: { $addToSet: "$_id" } ,
            count: { $sum : 1 }
        }
    },
    {
        "$match": {
            count: { "$gt": 1 }
        }
    }
   ]).forEach(function(doc) {
      doc.dups.shift();
      myDb.myCollection.remove({
          _id: {$in: doc.dups}
      });
   })

print("\n")

// print the results

myDb.myCollection.find({}).forEach(
    function(foundDoc){
        printjson(foundDoc)
    }
)
print("\n")
