// set the database and collection we want to use
myDb = db.getSiblingDB('myDb3')
collection = myDb.myCollection

// clear all collection records in advance of CRUD demo
deleteStatus = myDb.myCollection.deleteMany({})

/*
    CRUD
*/

// 2.1 Create a new document

print("\ncreating new document!\n---------\n")

employee = {
    "firstName": "John",
    "lastName": "Smith",
    "email": "johnsmith@example.com",
    "department": "IT",
    "password": "abc123",
    "location": { // embedded document

        "city": "Columbus",
        "state": "Ohio"
    }
}

// collection.insert(employee)

print("\ndone!\n")

print("\nupdating document!\n---------\n")

// 2.2 update the document
// update document with email johnsmith@example.com to have a new first name
updateStatus = myDb.myCollection.updateOne({ "email": "johnsmith@example.com" },
    {
        $set: {
            "firstName": "johnnyboy",
            "lastName": "Prometheus"
        }
    },
    {
        upsert: true,
    }
)

printjson(updateStatus)

// 2.3 read the document

print("\nreading document:\n-------------\n")

foundDoc = myDb.myCollection.findOne({ "email": "johnsmith@example.com" })
printjson(foundDoc)

// // 2.4 delete the document

// print("\deleting document:\n-------------\n")

// deleteStatus = myDb.myCollection.deleteOne({ "email": "johnsmith@example.com" })
// printjson(deleteStatus)
// print("\n")


// // /**
// //  *  More CRUD examples
// //  */

// // insert our original employee
// collection.insert(employee)

// // 2.5 update embedded document
// print("\nupdating document [embedded field] !\n---------\n")
// updateStatus = myDb.myCollection.updateOne({ "email": "johnsmith@example.com" },
//     { $set: { "location.city": "cincinatti" } })
// printjson(updateStatus)
// foundDoc = myDb.myCollection.findOne({ "email": "johnsmith@example.com" })
// printjson(foundDoc)
// print("\n")

// // 2.6 more update parameters
// // update, and delete methods all have associated *many function
// // these functions update/delete all matching documents

// print("\ndeleting all matching documents!\n---------\n")
// // insert our original employee again so that there are now two
// collection.insert(employee)
// // delete both records
// deleteStatus = myDb.myCollection.deleteMany({ "email": "johnsmith@example.com" })
// printjson(deleteStatus)
// print("\n")

// // 2.7 "multi" Parameter while updating multiple documents
// print("\nupdating multiple documents based on multiple fields!\n---------\n")
// // create two employee records 
// collection.insert(employee)
// collection.insert(employee)
// // update all records matching multiple criteria 
// updateStatus = myDb.myCollection.updateMany({ "email": "johnsmith@example.com", "lastName": "Rogers" },
//     { $set: { "department": "Narnia" } })
// printjson(updateStatus)
// print("\n")
// myDb.myCollection.find({ "email": "johnsmith@example.com" }).forEach(
//     function(foundDoc) {printjson(foundDoc)}
// )
// print("\n")